<!DOCTYPE html>
<html lang="cs">
  <head>
    <meta charset='UTF-8'>
    <meta name="author" content="Benjamin Verner">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="styles.css">
    <title>
    Úvod
    </title>
  </head>
  <body>
    <ul>
      <li class="menu"><a href="index.html">Úvod</a></li>
      <li class="menu"><a href="solver.html">SAT Solver</a></li>
      <li class="submenu">
        <a class="submenu-button">Konkrétní problémy</a>
        <div class="submenu-elements">
          <a href="pozorovani.html">Pozorování</a>
          <a href="sudoku.html">Sudoku</a>
          <a href="abc.html">Easy as ABC</a>
          <a href="logik.html">Logik</a>
          <a href="slitherlink.html">Slitherlink</a>
        </div>
      </li>
      <li class="menu"><a href="dokumentace.html">Technická dokumentace</a></li>
      <li class="menu"><a href="zaver.html">Závěr</a></li>
      <li class="menu"><a href="citace.html">Citace</a></li>
    </ul>
    <article>
      <h2 id="title">Technická dokumentace</h2>
      <section>
        <h3>Spouštění z konzole</h3>
        <p>Pro spuštění je třeba spustit soubor main.py:</p>
        <img src="arguments.png" alt="./main.py --type [source file]">
        <p>Jako parametr typu je možné zadat <i>sudoku</i>, <i>abc</i>, <i>logik</i> nebo <i>slitherlink</i>. Jako input lze zadat jakýkoli textový soubor, ale po úspěšné vyhodnocení puzzlu je potřeba dodržet strukturu puzzlu danou pro každý problém (viz Struktura vstupního souboru). Je možné zvolit variantu <i>progress</i> pro vykreslování postupu (obzvlášť hezké u Sudoku), je ale nutno dodat, že program se tím velice zpomalí. Doporučené použití je tedy pro vizualizaci procesu, ne pro získání výsledku.</p>
      </section>
      <section>
        <h3>Struktura vstupního souboru</h3>
        <p>Příklady jsou umístěny v projektu ve složce /puzzles. Vzhledem k tomu, že veškeré informace o problému (jako například velikost) musí program vyčíst ze zadaného souboru, je třeba, aby soubor přesně odpovídal požadavkům. Například nadbytečné mezery ve vstupním souboru jsou špatně interpretovány, proto je důležité, aby je soubor neobsahoval.</p>
      </section>
      <section>
        <h3>Sudoku</h3>
        <p>Jako validní vstup Sudoku problému skript bere N řádků o N znacích, kde na pozicích odpovídajících pozici v mřížce je umístěno buď dané číslo, nebo 0 pro identifikaci prázdných pozic.</p>
        <p>Pro zadání ilustračního obrázku (viz Konkrétní problémy: Sudoku) je vstup následující:</p>
        <div class="input">
          <p>530070000</p>
          <p>600195000</p>
          <p>098000060</p>
          <p>800060003</p>
          <p>400803001</p>
          <p>700020006</p>
          <p>060000280</p>
          <p>000419005</p>
          <p>000080079</p>
        </div>
      </section>
      <section>
        <h3>Easy as ABC</h3>
        <p>První řádek musí obsahovat všechna písmena, která jsou dovolena. Poté ve druhém řádku následuje přepis písmen nad mřížkou zleva doprava (pokud na pozici není žádné písmeno, je třeba napsat 0), ve třetím přepis písmen vpravo zezhora dolů, ve čtvrtém řádku přepis dolních písmen zleva doprava, a na posledním řádku písmen vlevo zezhora dolů.</p>
        <p>Tedy pro zadání ilustračního obrázku (viz 3.2) by vstupní soubor vypadal následovně:</p>
        <div class="input">
          <p>ABC</p>
          <p>0C00</p>
          <p>00A0</p>
          <p>00B0</p>
          <p>000B</p>
        </div>
      </section>
      <section>
        <h3>Logik</h3>
        <p>Soubor musí obsahovat pro každé zadané slovo řádek, na kterém je napsané ono slovo, poté mezera, a nakonec počet + odpovídající počtu černých nápověd a počet - odpovídající počtu bílých nápověd.</p>
        <div class="input">
          <p>hoop -</p>
          <p>hype --</p>
          <p>euro +--</p>
          <p>ever +</p>
          <p>heir -</p>
          <p>hike -</p>
        </div>
      </section>
      <section>
        <h3>Slitherlink</h3>
        <p>U Slitherlinku je vstup podobný vstupu Sudoku. Pro mřížku NxN je zadáním N řádků o N znacích, kde pro číslo na dané pozici je znakem ono čislo, pro prázdnou pozici 'x'.</p>
        <p>Zadání ilustračního obrázku by vypadalo takto:</p>
        <div class="input">
          <p>2xx0</p>
          <p>1x2x</p>
          <p>33xx</p>
          <p>x1x3</p>
        </div>
      </section>
    </article>
  </body>
</html>
